Hot News:

Mit Unterstützung durch:

  Foren auf CAD.de (alle Foren)
  CATIA V5 Programmierung
  Mit DisplayName auf Product/Instanz zugreifen

Antwort erstellen  Neues Thema erstellen
CAD.de Login | Logout | Profil | Profil bearbeiten | Registrieren | Voreinstellungen | Hilfe | Suchen

Anzeige:

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen nächster neuer Beitrag | nächster älterer Beitrag
  
Die Gewinne der Zukunft werden mit intelligenten, autonomen Elektrofahrzeugen eingefahren.
Autor Thema:   Mit DisplayName auf Product/Instanz zugreifen (103 mal gelesen)
Lionel Hutz
Mitglied



Sehen Sie sich das Profil von Lionel Hutz an!   Senden Sie eine Private Message an Lionel Hutz  Schreiben Sie einen Gästebucheintrag für Lionel Hutz

Beiträge: 191
Registriert: 26.03.2014

CATIA V5 R20

erstellt am: 16. Sep. 2020 09:17    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Ich probiere gerade auf eine Instanz zuzugreifen, die mit einem Constraint verbunden ist.
Bisher bin ich vom Constraint bis zum DisplayName gekommen; jetzt möchte ich auf die Instanz zugreifen um abzugleichen, ob das Bauteil selektiert ist.

Code:
Language="VBSCRIPT"

Sub CATMain()
Set oDoc = CATIA.ActiveDocument
Set oProduct = oDoc.Product
Set oConstraints = oDoc.Product.Connections("CATIAConstraints")

Set oConstraint = oConstraints.Item(1)
Set oConstraintElement1 = oConstraint.GetConstraintElement(1)
MsgBox "DisplayName: " & oConstraintElement1.DisplayName
Set oConstraintProduct1 = oProduct.FindObjectByName(oConstraintElement1.DisplayName)
MsgBox oConstraintProduct1.Name

End Sub



In der fett gedruckten Zeile steigt das Makro aus. Ich vermute, dass FindObjectByName für PartDesign ist.
Wie erhalte ich Zugriff auf die Instanz?

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

bgrittmann
Moderator
Konstrukteur


Sehen Sie sich das Profil von bgrittmann an!   Senden Sie eine Private Message an bgrittmann  Schreiben Sie einen Gästebucheintrag für bgrittmann

Beiträge: 11110
Registriert: 30.11.2006

CATIA V5R19

erstellt am: 16. Sep. 2020 14:02    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für Lionel Hutz 10 Unities + Antwort hilfreich

Servus Lionel

Der Displayname hat folgenden Aufbau RootproductName/InstanceName/!GeoElementName (sehr einfaches Beipeil).
Ich würde den String zerlegen (String zwischen 1. und 2. "/") und dann per Namen der Products-Collection auf die Instanz zugreifen.

Gruß
Bernd

------------------
Warum einfach, wenn es auch kompliziert geht.

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Lionel Hutz
Mitglied



Sehen Sie sich das Profil von Lionel Hutz an!   Senden Sie eine Private Message an Lionel Hutz  Schreiben Sie einen Gästebucheintrag für Lionel Hutz

Beiträge: 191
Registriert: 26.03.2014

CATIA V5 R20

erstellt am: 16. Sep. 2020 15:29    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Code:
sDisplayname = split(oConstraintElement1.DisplayName,"/")
Set oConstraintProduct1 = oProducts.item(sDisplayName(1))


Übrigens vorab Glückwunsch zum 11111. Beitrag.

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Anzeige.:

Anzeige: (Infos zum Werbeplatz >>)

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen

nächster neuerer Beitrag | nächster älterer Beitrag
Antwort erstellen


Diesen Beitrag mit Lesezeichen versehen ... | Nach anderen Beiträgen suchen | CAD.de-Newsletter

Administrative Optionen: Beitrag schliessen | Archivieren/Bewegen | Beitrag melden!

Fragen und Anregungen: Kritik-Forum | Neues aus der Community: Community-Forum

(c)2020 CAD.de | Impressum | Datenschutz